{ taskCore.impl.p	  Copyright G. Sawitzki, 1988-1991}

{****************************** core computation - low level ************}
function NoPicture:picHandle;
var anyHandle:PicHandle;
	l:longint;s:str255;
	safeport:GrafPtr;
begin
		getport(safeport);
		setport(baseWindow);
		anyhandle:=OpenPicture(ThePort^.portrect);
		moveto(20,20);
		 numtostring(tickcount,s);
		 drawstring(concat('No Picture ',s));
		 closepicture;
		setPort(safeport);
		NoPicture:=anyHandle;
end;

{$SETC xxx=true} {work around a bug in MPW pascal 3.2bX}

{$IFC xxx}
function nextPicture(count:integer;var stat:extended):PicHandle;
var displaymode:integer;l:longint;
begin
	stat:=0;{default}l:=longint(cDefaultDistribution);
	if not theConfiguration.GenerateSamples then 
	begin
		NextPicture:=NoPicture;
		stat:=0;
	end
	else 	tToy_nextToy(l,count,stat);
		nextPicture:=tToy_drawToy(tToy_DrawScatter); 
end;
{$ELSEC}
function nextPicture(count:integer;var stat:extended):PicHandle;
var displaymode:integer;
begin
	stat:=0;{default}
	if not theConfiguration.GenerateSamples then NextPicture:=NoPicture 
	else 	tToy_nextToy(longint(cDefaultDistribution),count,stat);
		nextPicture:=tToy_drawToy(tToy_DrawScatter); 
end;
{$ENDC}

PROCEDURE PutPicture(VAR p:pichandle);
VAR anyHandle:PicHandle;
	l:longint;s:str255;
	safeport:GrafPtr;
	screvent:EventRecord;
BEGIN
	l:=tickCount;
	IF (master | visible) THEN BEGIN
		getport(safeport);
		setport(baseWindow);
		anyHandle:=getWindowPic(BaseWindow);
		IF anyHandle<>NIL THEN killPicture(anyHandle);
		{attach the picture to our window for automatic playback}
		setwindowpic(BaseWindow, p);
		p:=NIL;{make sure it belongs to the window}
		eraseRect(BaseWindow^.portrect);

		invalrect(BaseWindow^.portrect);

		setPort(safeport);
	END ELSE IF p<>NIL THEN 
	BEGIN 
		killPicture(p);
		p:=NIL;
	END;
END;

PROCEDURE DefaultPicture(VAR msghdr:tMsgHeader; VAR moreinfo:handle);
VAR anyHandle:PicHandle;
	l:longint;s:str255;
	safeport:GrafPtr;
BEGIN
	l:=tickCount;
	IF (Master | visible) THEN BEGIN
		getport(safeport);
		setport(baseWindow);
		anyHandle:=getWindowPic(BaseWindow);
		IF anyHandle<>NIL THEN killPicture(anyHandle);
		anyhandle:=OpenPicture(ThePort^.portrect);
		moveto(20,20);
		drawstring('dummy default picture');
		closepicture;
		setwindowpic(BaseWindow, anyhandle);
		eraseRect(BaseWindow^.portrect);
		invalrect(BaseWindow^.portrect);
		setPort(safeport);
	END ELSE;
	IF moreinfo<>NIL THEN BEGIN disposhandle(moreinfo);moreinfo:=NIL; END;
END;

{****************************** computation *****************************}

{for control of timing, the task is broken down to three components which can
be used for both master and slave}
Procedure DefineTask(var myMsgHeader:tMsgHeader);
var tempstr,s:str255;
	l:longint;
begin
	l:=tickcount;
	prepareMessageHeader(myMsgHeader,aExample);

	l:=tickcount-l;
end;

function DoTaskCore(var myMsgHeader:tMsgHeader):handle;
var tempstr,s:str255;
	l:longint;
begin
	l:=tickcount;
	DoTaskCore:=handle(NextPicture(myMsgHeader.SampleSize,myMsgHeader.SampleStat));
	myMsgHeader.ContentsToken:=longint('PICT');

	l:=tickcount-l;
end;

procedure sNoteResult(isLocal:boolean);
var tempticks,deltaticks:longint;
	s:str255;x:integer;
begin
	tempticks:=sLastTicks;
	sLastTicks:=tickCount;
	deltaticks:=sLastTicks-tempticks;
	{sMeanTicks:=(19*sMeanTicks+(deltaticks))*0.05;}{moving average over 20}
	sMeanTicks:=(9*sMeanTicks+(deltaticks))*0.1;	{moving average over 10}
	numtostring(deltaticks,s);

	NrResults:=NrResults+1;
	
	
end;

PROCEDURE DoTaskUpdate(VAR h:handle; VAR myMsgHeader:tMsgHeader;islocal:boolean);
VAR tempstr,s:str255;
	l:longint;
	h1:handle;
BEGIN
	l:=tickcount;
	IF myMsgHeader.ContentsToken=longint('PICT') 
	THEN BEGIN 
		IF myMsgHeader.SampleStat < MinRecord THEN BEGIN
			MinRecord:=myMsgHeader.SampleStat;

			h1:=h;
			IF HandToHand(Handle(h1)) = noErr THEN 
			BEGIN KillPicture(MinPic);MinPic:=PicHandle(h1);END;
			NewRecordPicture;
		END;
		IF myMsgHeader.SampleStat > MaxRecord THEN BEGIN
			MaxRecord:=myMsgHeader.SampleStat;

			h1:=h;
			IF HandToHand(Handle(h1)) = noErr THEN 
			BEGIN KillPicture(MaxPic);MaxPic:=PicHandle(h1);END;
			NewRecordPicture;
		END;

		IF isLocal THEN PutPicture(PicHandle(h));
	END	ELSE BEGIN 
		IF isLocal THEN DefaultPicture(myMsgHeader,h);
	END;

	IF master THEN NoteStatistics(myMsgHeader.SampleStat,islocal);
	l:=tickcount-l;


	{update all statistics to account for a new result}

END;

{**********************************************}
procedure DoLocalTask;
var anyHandle:picHandle;
	l:longint;s:str255;
	myMsgHeader:tMsgHeader;
begin 
	DefineTask(myMsgHeader);

	anyHandle:=PicHandle(DoTaskCore(myMsgHeader));
	DoTaskUpdate(handle(anyHandle),myMsgHeader,true);
end;
			
